<template>
  <div class="main-content stats-page">
    <h1 class="stats-page-header">
      узнайте о
      <br />о самых
      <b>горячих</b>
      <br />месяцах в году
    </h1>

    <div class="stats-page-content">
      <p>
        С другой стороны начало повседневной работы по формированию позиции
        обеспечивает широкому кругу (специалистов) участие в формировании
        существенных финансовых и административных условий. Идейные соображения
        высшего порядка, а также укрепление и развитие структуры способствует
        подготовки и реализации новых предложений.
      </p>
      <p>
        Идейные соображения высшего порядка, а также новая модель
        организационной деятельности позволяет оценить значение системы обучения
        кадров, соответствует насущным потребностям.
      </p>
      <p>
        Значимость этих проблем настолько очевидна, что постоянный
        количественный рост и сфера нашей активности в значительной степени
        обуславливает создание системы обучения кадров, соответствует насущным
        потребностям. Не следует, однако забывать, что рамки и место обучения
        кадров требуют от нас анализа систем массового участия.
      </p>

      <h2>Статистика</h2>
      <div class="stats-page-diagram-block">
        <div class="first-column">
          <div class="diagram-card">
            <div class="diagram-card-heading">
              <div>
                Брачная статистика
                <br />в виде карты попаданий
              </div>
              <div>
                <template v-for="type in types">
                  <a
                    class="chose"
                    :class="{ active: type.code == typeSelect }"
                    @click="typeSelect = type.code"
                    :key="type.code"
                    >{{ type.name }}</a
                  >,&nbsp;
                </template>
              </div>
            </div>
            <div class="diagram-card-content">
              <heat-chart
                :series="series"
                :categorys="categorys"
                :colors="heatColors"
                :mouse-move-event="mouseMoveEvent"
              />
            </div>
          </div>
        </div>
        <div>
          <div class="diagram-card">
            <div class="diagram-card-heading">
              Соотношение бракосочетаний и расторжений брака
            </div>
            <div class="diagram-card-content">
              <pie-chart :series="circleSeries" />
              <div class="diagram-card-piechart-legend">
                <div
                  class="piechart-legend-item"
                  :key="`row-${index}`"
                  v-for="(item, index) in circleSeries"
                >
                  <i :style="{ borderColor: item.color }"></i>
                  {{ item.name }}
                </div>
              </div>
            </div>
          </div>
          <div class="diagram-card blue mt-18">
            <div class="diagram-card-content">
              <div class="card-total-block">
                <div>Среднее:</div>
                <div>
                  <div class="total">{{ totalProc }}%</div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <p>
        С другой стороны начало повседневной работы по формированию позиции
        обеспечивает широкому кругу (специалистов) участие в формировании
        существенных финансовых и административных условий. Идейные соображения
        высшего порядка, а также укрепление и развитие структуры способствует
        подготовки и реализации новых предложений.
      </p>
      <p>
        Идейные соображения высшего порядка, а также новая модель
        организационной деятельности позволяет оценить значение системы обучения
        кадров, соответствует насущным потребностям.
      </p>
      <p>
        Значимость этих проблем настолько очевидна, что постоянный
        количественный рост и сфера нашей активности в значительной степени
        обуславливает создание системы обучения кадров, соответствует насущным
        потребностям. Не следует, однако забывать, что рамки и место обучения
        кадров требуют от нас анализа систем массового участия.
      </p>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import HeatChart from "@/components/charts/HeatChart.vue";
import PieChart from "@/components/charts/PieChart.vue";
import rest from "@/rest";
import _ from "lodash";

@Component({
  components: { HeatChart, PieChart }
})
export default class StatsWeddingPage extends Vue {
  marriageData: any = [];
  categorys: any = [];
  selectData: Array<number> = [0, 0];
  colors = ["#F7004A", "#109CF1"];

  types = [
    { code: "weeding", name: "Свадеб" },
    { code: "divorce", name: "Разводов" },
    { code: "saldo", name: "Разность" }
  ];
  typeSelect = "weeding";

  mouseMoveEvent(option: any) {
    this.selectData = [
      option.seriesIndex > -1 ? option.seriesIndex : 0,
      option.dataPointIndex > -1 ? option.dataPointIndex : 0
    ];
  }

  get heatColors() {
    switch (this.typeSelect) {
      case "weeding":
        return ["#f8014b"];

      case "divorce":
        return ["#ffda1e"];

      case "saldo":
        return ["#6F5BE0"];

      default:
        return ["#f8014b"];
    }
  }

  get totalProc() {
    return 64;
  }

  get circleSeries() {
    let month = this.series[this.selectData[0]].data[this.selectData[1]];
    return [
      {
        value: month.weeding,
        name: "Свадеб",
        color: "#f8014b"
      },
      {
        value: month.divorce,
        name: "Разводов",
        color: "#ffda1e"
      }
    ];
  }

  get series() {
    let series = [];
    let years = [];
    let months = [
      "Янв",
      "Фев",
      "Мар",
      "Апр",
      "Май",
      "Июн",
      "Июл",
      "Авг",
      "Сен",
      "Окт",
      "Ноя",
      "Дек"
    ];
    for (let year in this.marriageData) {
      series.push({
        name: year,
        data: _.map(this.marriageData[year], (item: any) => {
          let data: any = {
            x: months[item.x],
            weeding: item.y,
            divorce: item.z,
            saldo: item.y - item.z
          };

          data.y = data[this.typeSelect];

          return data;
        })
      });
    }
    return series.reverse();
  }

  mounted() {
    rest.marriage_count
      .get()
      .then((result: any) => {
        this.marriageData = result.data;
      })
      .catch((err: any) => {});
  }
}
</script>
